#include "abstractcontrolobj.h"

AbstractControlObj::AbstractControlObj(ObjType objType)
    : AbstractObj(objType)
{
    nameProperty = new GenericPlainStringProperty("name", "Name", AbstractDelegate::Name);
    nameProperty->setValue("myobj");
    appendProperty(nameProperty);

    xProperty = new GeometryDataProperty(GeometryDataProperty::X);
    xProperty->setValue("0");
    appendProperty(xProperty);

    yProperty = new GeometryDataProperty(GeometryDataProperty::Y);
    yProperty->setValue("0");
    appendProperty(yProperty);

    xSizeProperty = new GeometryDataProperty(GeometryDataProperty::XSize);
    xSizeProperty->setValue(".");
    appendProperty(xSizeProperty);

    ySizeProperty = new GeometryDataProperty(GeometryDataProperty::YSize);
    ySizeProperty->setValue(".");
    appendProperty(ySizeProperty);
}

bool AbstractControlObj::hasName() const
{
    return true;
}
