#ifndef ABSTRACTMULTIMODALITYDELEGATE_H
#define ABSTRACTMULTIMODALITYDELEGATE_H

#include "abstractdelegate.h"

class AbstractMultiModalityDelegate : public AbstractDelegate
{
public:
    AbstractMultiModalityDelegate(QObject *parent);

    virtual QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                          const QModelIndex &index) const;
    virtual void setEditorData(QWidget *editor, const QModelIndex &index) const;
    virtual void setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const;

    void setModalities(const QList<QString> &editRoleModalities,
                       const QList<QString> &displayRoleModalities);

private:
    QList<QString> m_editRoleModalities;
    QList<QString> m_displayRoleModalities;
};

#endif // ABSTRACTMULTIMODALITYDELEGATE_H
