#include "abstractproperty.h"

AbstractProperty::AbstractProperty()
{
}

QVariant AbstractProperty::displayRoleData() const
{
    return m_displayRoleDataString;
}

QString AbstractProperty::commandString() const
{
    return m_commandString;
}

QVariant AbstractProperty::editRoleData() const
{
    return m_value;
}

bool AbstractProperty::setEditRoleData(const QVariant &data)
{
    setValue(data.toString());
    return true;
}

void AbstractProperty::setValue(const QString &valueString)
{
    m_value = valueString;
    m_displayRoleDataString = updateDisplayRoleDataString(valueString);
    m_commandString = updateCommandString(valueString);
}

void AbstractProperty::setFromObjDomElement(const QDomElement &domElement)
{
    QDomNode domNode = domElement.namedItem(domElementName());
    if (domNode.isNull())
        setValue("");
    else
    {
        QDomElement domElement = domNode.toElement();
        setValue(domElement.childNodes().at(0).toText().data());
    }

}

QDomElement AbstractProperty::domElement(QDomDocument &xmlDocument) const
{
    if (m_value.isEmpty())
        return QDomElement();
    else
    {
        QDomElement domElement = xmlDocument.createElement(domElementName());
        QDomText domText = xmlDocument.createTextNode(m_value);
        domElement.appendChild(domText);
        return domElement;
    }
}


