#ifndef ABSTRACTPROPERTY_H
#define ABSTRACTPROPERTY_H

#include <QString>
#include <QVariant>
#include <QDomDocument>
#include "abstractdelegate.h"

class AbstractProperty
{
public:
    AbstractProperty();

    // Pure virtual functions
    virtual QVariant updateDisplayRoleDataString(const QString &valueString) = 0;
    virtual QString updateCommandString(const QString &valueString) = 0;
    virtual QString domElementName() const = 0;
    virtual QVariant propertyNameForDisplayRoleData() const = 0;
    virtual bool isRequired() const = 0;
    virtual AbstractDelegate::DelegateType delegateForProperty() const = 0;

    // Virtual functions
    virtual void setFromObjDomElement(const QDomElement &domElement);
    virtual QDomElement domElement(QDomDocument &xmlDocument) const;

    QVariant displayRoleData() const;
    QString commandString() const;
    QVariant editRoleData() const;
    bool setEditRoleData(const QVariant &data);
    void setValue(const QString &valueString);
    QString value() const {return m_value;}

private:
    QString m_value;
    QVariant m_displayRoleDataString;
    QString m_commandString;
};

#endif // ABSTRACTPROPERTY_H
