#include "buttonobj.h"

ButtonObj::ButtonObj()
    :AbstractControlObj(AbstractObj::Button)
{
    xSizeProperty->setValue(".");
    ySizeProperty->setValue(".");


    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    onPushProperty =
            new GenericLabeledStringProperty("onpush", "On push", AbstractDelegate::IAction);
    appendProperty(onPushProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);
}

QString ButtonObj::commandString() const
{
    return "BUTTON" + standardInnerCommandString();
}

QString ButtonObj::commandNameForDisplayRoleData() const
{
    return "Button";
}

QString ButtonObj::typeNameForDomElement() const
{
    return "button";
}

