#include "cancelobj.h"

#include "genericplainstringproperty.h"
#include "genericlabeledstringproperty.h"

CancelObj::CancelObj()
    : AbstractObj(AbstractObj::Cancel)
{
    GenericPlainStringProperty *nameProperty =
            new GenericPlainStringProperty("name", "Name", AbstractDelegate::Name);
    nameProperty->setValue("mycancelbutton");
    appendProperty(nameProperty);

    GenericLabeledStringProperty *label =
            new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(label);
}

QString CancelObj::commandString() const
{
    return "CANCEL" + standardInnerCommandString();
}

QString CancelObj::commandNameForDisplayRoleData() const
{
    return "Cancel button";
}

QString CancelObj::typeNameForDomElement() const
{
    return "cancel";
}

bool CancelObj::hasName() const
{
    return true;
}
