#ifndef CHECKBOXOBJ_H
#define CHECKBOXOBJ_H

#include "abstractcontrolobj.h"

// Properties
#include "genericlabeledstringproperty.h"
#include "genericbooleanproperty.h"

class CheckBoxObj : public AbstractControlObj
{
public:
    CheckBoxObj();

    // Re-implemented pure virtual functions
    virtual QString commandString() const;
    virtual QString commandNameForDisplayRoleData() const;
    virtual QString typeNameForDomElement() const;

    // Properties
    GenericLabeledStringProperty *labelProperty;
    GenericLabeledStringProperty *errorProperty;
    GenericLabeledStringProperty *defaultProperty;
    GenericBooleanProperty *noMemoryProperty;
    GenericBooleanProperty *groupBoxProperty;
    GenericLabeledStringProperty *onClickOnProperty;
    GenericLabeledStringProperty *onClickOffProperty;
    GenericLabeledStringProperty *optionProperty;
    GenericLabeledStringProperty *toolTipProperty;
};

#endif // CHECKBOXOBJ_H
