#include "colordelegate.h"
#include "colorsetter.h"

ColorDelegate::ColorDelegate(QObject *parent)
    : AbstractDelegate(parent)
{
}

QWidget *ColorDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
              const QModelIndex &index) const
{
    Q_UNUSED(option)
    Q_UNUSED(index)
    ColorSetter *colorSetter = new ColorSetter(parent);
    return colorSetter;
}

void ColorDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    ColorSetter *colorSetter = static_cast<ColorSetter*>(editor);
    colorSetter->setData(index.data(Qt::EditRole).toString());
}

void ColorDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                            const QModelIndex &index) const
{
    ColorSetter *colorSetter = static_cast<ColorSetter*>(editor);
    model->setData(index, colorSetter->data());
}
