#include "comboboxforcanvas.h"

ComboBoxForCanvas::ComboBoxForCanvas(const QRect &rect, const QString &comboBoxType,
                                     const QWidget *widget)
    : AbstractObjForCanvas(rect), widget(widget), m_comboBoxType(comboBoxType)
{
    if (m_comboBoxType == "regular" || m_comboBoxType == "")
    {
        // Line edit
        styleOptionLineEdit.initFrom(widget);
        styleOptionLineEdit.rect = rect;
        styleOptionLineEdit.rect.setHeight(21);

        // Frame
        if (rect.height() > 21)
        {
            frameOfRegularComboBoxIsVisible = true;
            styleOptionFrame.initFrom(widget);
            styleOptionFrame.rect.setX(rect.x());
            styleOptionFrame.rect.setY(rect.y() + 21);
            styleOptionFrame.rect.setWidth(rect.width());
            if (rect.height() > 60) // ok
                styleOptionFrame.rect.setHeight(rect.height() - 38);
            else // to be reviewed
                styleOptionFrame.rect.setHeight(rect.height() - 21);
        }
        else
            frameOfRegularComboBoxIsVisible = false;
    }
    else if (m_comboBoxType == "dropdown")
    {
        // Line edit
        styleOptionLineEdit.initFrom(widget);
        styleOptionLineEdit.rect = rect;
        styleOptionLineEdit.rect.setHeight(21);

        // Arrow
        styleOptionArrow.initFrom(widget);
        styleOptionArrow.rect.setX(rect.x() + rect.width() - 13);
        styleOptionArrow.rect.setY(rect.y() + 6);
        styleOptionArrow.rect.setWidth(10);
        styleOptionArrow.rect.setHeight(10);
    }
    else if (m_comboBoxType == "dropdownlist")
    {
        styleOptionComboBox.initFrom(widget);
        styleOptionComboBox.rect = rect;
        styleOptionComboBox.rect.setHeight(21);
        styleOptionComboBox.frame = true;
    }
}

void ComboBoxForCanvas::draw(QPainter *painter) const
{
    if (m_comboBoxType == "regular" || m_comboBoxType == "")
    {
        widget->style()->drawPrimitive(QStyle::PE_FrameLineEdit, &styleOptionLineEdit, painter, widget);
        widget->style()->drawPrimitive(QStyle::PE_Frame, &styleOptionFrame, painter, widget);
    }
    else if (m_comboBoxType == "dropdown")
    {
        widget->style()->drawPrimitive(QStyle::PE_FrameLineEdit, &styleOptionLineEdit, painter, widget);
        widget->style()->drawPrimitive(QStyle::PE_IndicatorArrowDown, &styleOptionArrow, painter, widget);
    }
    else if (m_comboBoxType == "dropdownlist")
    {
        widget->style()->drawComplexControl(QStyle::CC_ComboBox, &styleOptionComboBox, painter, widget);
    }
}
