#include "comboboxobj.h"

ComboBoxObj::ComboBoxObj()
    : AbstractControlObj(AbstractObj::ComboBox)
{
    xSizeProperty->setValue("200");
    ySizeProperty->setValue("100");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    comboBoxTypeProperty = new ComboBoxTypeProperty;
    appendProperty(comboBoxTypeProperty);

    defaultProperty =
            new GenericLabeledStringProperty("default", "Default", AbstractDelegate::DefaultStrVal);
    appendProperty(defaultProperty);

    noMemoryProperty =
            new GenericBooleanProperty("nomemory", "No memory", AbstractDelegate::NoMemory);
    appendProperty(noMemoryProperty);

    contentsProperty = new ContentsProperty;
    appendProperty(contentsProperty);

    valuesProperty =
            new GenericLabeledStringProperty("values", "Values", AbstractDelegate::Values);
    appendProperty(valuesProperty);

    appendPropertyProperty
            = new GenericBooleanProperty("append", "Append", AbstractDelegate::Append);
    appendProperty(appendPropertyProperty);

    onSelChangeProperty =
            new GenericLabeledStringProperty("onselchange", "On selection changed",
                                             AbstractDelegate::IAction);
    appendProperty(onSelChangeProperty);

    onSelChangeListProperty =
            new GenericLabeledStringProperty("onselchangelist", "On selection changed list",
                                             AbstractDelegate::IAction);
    appendProperty(onSelChangeListProperty);

    optionProperty =
            new GenericLabeledStringProperty("option", "Option", AbstractDelegate::GenericString);
    appendProperty(optionProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);
}

QString ComboBoxObj::commandString() const
{
    return "COMBOBOX" + standardInnerCommandString();
}

QString ComboBoxObj::commandNameForDisplayRoleData() const
{
    return "Combo box";
}

QString ComboBoxObj::typeNameForDomElement() const
{
    return "combobox";
}

