#include "contentsdelegate.h"

#include "contentssetter.h"
#include "abstractobj.h"
#include "listobj.h"
#include "model.h"

#include <QSortFilterProxyModel>

ContentsDelegate::ContentsDelegate(QObject *parent)
    : AbstractDelegate(parent)
{
}

QWidget *ContentsDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
              const QModelIndex &index) const
{
    Q_UNUSED(option)
    const QSortFilterProxyModel *proxyModel = static_cast<const QSortFilterProxyModel*>(index.model());
    QModelIndex sourceIndex = proxyModel->mapToSource(index);
    const QAbstractItemModel *sourceModel = sourceIndex.model();
    QStringList userDefinedLists;
    for (int i=0; i<sourceModel->rowCount(); i++)
    {
        QModelIndex ind = sourceModel->index(i, 0, QModelIndex());
        AbstractObj *obj = static_cast<AbstractObj*>(ind.internalPointer());
        if (obj->objType() == AbstractObj::List)
        {
            ListObj *listObj = static_cast<ListObj*>(obj);
            userDefinedLists << listObj->nameProperty->editRoleData().toString();
        }
    }
    ContentsSetter *contentsSetter = new ContentsSetter(userDefinedLists, parent);
    return contentsSetter;
}

void ContentsDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    ContentsSetter *contentsSetter = static_cast<ContentsSetter*>(editor);
    contentsSetter->setContentsData(index.data(Qt::EditRole).toString());
}

void ContentsDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                            const QModelIndex &index) const
{
    ContentsSetter *contentsSetter = static_cast<ContentsSetter*>(editor);
    model->setData(index, contentsSetter->contentsData());
}
