#include "copyobj.h"

#include "genericplainstringproperty.h"
#include "genericlabeledstringproperty.h"

CopyObj::CopyObj()
    : AbstractObj(AbstractObj::Copy)
{
    GenericPlainStringProperty *nameProperty =
            new GenericPlainStringProperty("name", "Name", AbstractDelegate::Name);
    nameProperty->setValue("mycancelbutton");
    appendProperty(nameProperty);

    GenericLabeledStringProperty *uActionProperty =
            new GenericLabeledStringProperty("uaction", "U-Action", AbstractDelegate::UAction);
    appendProperty(uActionProperty);

    GenericLabeledStringProperty *targetProperty =
            new GenericLabeledStringProperty("target", "Target", AbstractDelegate::Target);
    appendProperty(targetProperty);
}

QString CopyObj::commandString() const
{
    return "COPY" + standardInnerCommandString();
}

QString CopyObj::commandNameForDisplayRoleData() const
{
    return "Copy button";
}

QString CopyObj::typeNameForDomElement() const
{
    return "copy";
}

bool CopyObj::hasName() const
{
    return true;
}
