#include "defaultstrvaldelegate.h"
#include "defaultsetter.h"

DefaultStrValDelegate::DefaultStrValDelegate(QObject *parent)
    : AbstractDelegate(parent)
{
}

QWidget *DefaultStrValDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
              const QModelIndex &index) const
{
    Q_UNUSED(option)
    Q_UNUSED(index)
    DefaultSetter *defaultSetter = new DefaultSetter(DefaultSetter::StrVal, parent);
    return defaultSetter;
}

void DefaultStrValDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    DefaultSetter *defaultSetter = static_cast<DefaultSetter*>(editor);
    defaultSetter->setDefaultValue(index.data(Qt::EditRole).toString());
}

void DefaultStrValDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                            const QModelIndex &index) const
{
    DefaultSetter *defaultSetter = static_cast<DefaultSetter*>(editor);
    model->setData(index, defaultSetter->defaultValue());
}

