#ifndef EDITOBJ_H
#define EDITOBJ_H

#include "abstractcontrolobj.h"

// Properties
#include "genericlabeledstringproperty.h"
#include "genericbooleanproperty.h"
#include "maxforeditproperty.h"

class EditObj : public AbstractControlObj
{
public:
    EditObj();

    // Re-implemented pure virtual functions
    virtual QString commandString() const;
    virtual QString commandNameForDisplayRoleData() const;
    virtual QString typeNameForDomElement() const;

    // Properties
    GenericLabeledStringProperty *labelProperty;
    GenericLabeledStringProperty *errorProperty;
    GenericLabeledStringProperty *defaultProperty;
    GenericBooleanProperty *noMemoryProperty;
    MaxForEditProperty *maxForEditProperty;
    GenericBooleanProperty *numOnlyProperty;
    GenericBooleanProperty *passwordProperty;
    GenericLabeledStringProperty *onChangeProperty;
    GenericLabeledStringProperty *optionProperty;
    GenericLabeledStringProperty *toolTipProperty;
};

#endif // EDITOBJ_H
