#include "expforcanvas.h"

ExpForCanvas::ExpForCanvas(const QRect &rect, const QString &label, const QWidget *widget)
    : AbstractObjForCanvas(rect), widget(widget)
{
    // Line edit
    styleOptionLineEdit.initFrom(widget);
    if (rect.width() - 75 - 4 > 0)
    {
        styleOptionLineEdit.rect.setX(rect.x());
        styleOptionLineEdit.rect.setY(rect.y());
        styleOptionLineEdit.rect.setWidth(rect.width() - 75 - 1);
        styleOptionLineEdit.rect.setHeight(rect.height());
    }
    else
    {
        styleOptionLineEdit.rect.setX(0);
        styleOptionLineEdit.rect.setY(0);
        styleOptionLineEdit.rect.setWidth(0);
        styleOptionLineEdit.rect.setHeight(0);
    }

    // Button
    styleOptionButton.initFrom(widget);
    styleOptionButton.rect.setX(rect.x() + rect.width() - 75);
    styleOptionButton.rect.setY(rect.y());
    styleOptionButton.rect.setWidth(75);
    styleOptionButton.rect.setHeight(rect.height());
    styleOptionButton.text = label;
}

void ExpForCanvas::draw(QPainter *painter) const
{
    widget->style()->drawPrimitive(QStyle::PE_FrameLineEdit, &styleOptionLineEdit, painter, widget);
    widget->style()->drawControl(QStyle::CE_PushButton, &styleOptionButton, painter, widget);
}
