#ifndef EXPOBJ_H
#define EXPOBJ_H

#include "abstractcontrolobj.h"

// Properties
#include "genericlabeledstringproperty.h"
#include "genericbooleanproperty.h"

class ExpObj : public AbstractControlObj
{
public:
    ExpObj();

    // Re-implemented pure virtual functions
    virtual QString commandString() const;
    virtual QString commandNameForDisplayRoleData() const;
    virtual QString typeNameForDomElement() const;

    // Properties
    GenericLabeledStringProperty *labelProperty;
    GenericLabeledStringProperty *errorProperty;
    GenericLabeledStringProperty *defaultProperty;
    GenericBooleanProperty *noMemoryProperty;
    GenericLabeledStringProperty *onChangeProperty;
    GenericLabeledStringProperty *optionProperty;
    GenericLabeledStringProperty *toolTipProperty;
};

#endif // EXPOBJ_H
