#ifndef FILEOBJ_H
#define FILEOBJ_H

#include "abstractcontrolobj.h"

// Properties
#include "genericlabeledstringproperty.h"
#include "genericbooleanproperty.h"

class FileObj : public AbstractControlObj
{
public:
    FileObj();

    // Re-implemented pure virtual functions
    virtual QString commandString() const;
    virtual QString commandNameForDisplayRoleData() const;
    virtual QString typeNameForDomElement() const;

    // Properties
    GenericLabeledStringProperty *labelProperty;
    GenericLabeledStringProperty *errorProperty;
    GenericLabeledStringProperty *defaultProperty;
    GenericBooleanProperty *noMemoryProperty;
    GenericLabeledStringProperty *buttonWidthProperty;
    GenericLabeledStringProperty *dialogTitleForFileObjProperty;
    GenericBooleanProperty *saveProperty;
    GenericBooleanProperty *multiSelectProperty;
    GenericLabeledStringProperty *filterProperty;
    GenericLabeledStringProperty *onChangeProperty;
    GenericLabeledStringProperty *optionProperty;
    GenericLabeledStringProperty *toolTipProperty;
};

#endif // FILEOBJ_H
