#include "genericbooleanproperty.h"

GenericBooleanProperty::GenericBooleanProperty(const QString &nameForDomElement,
                                               const QString &nameForDisplayRoleData,
                                               AbstractDelegate::DelegateType delegateType)
{
    m_nameForDomElement = nameForDomElement;
    m_nameForDisplayRoleData = nameForDisplayRoleData;
    m_delegateType = delegateType;
    setValue("");
}

QVariant GenericBooleanProperty::updateDisplayRoleDataString(const QString &valueString)
{
    if (valueString.isEmpty())
        return "False";
    else
        return "True";
}

QString GenericBooleanProperty::updateCommandString(const QString &valueString)
{
    return valueString;
}

QString GenericBooleanProperty::domElementName() const
{
    return m_nameForDomElement;
}

QVariant GenericBooleanProperty::propertyNameForDisplayRoleData() const
{
    return m_nameForDisplayRoleData;
}

bool GenericBooleanProperty::isRequired() const
{
    return false;
}

AbstractDelegate::DelegateType GenericBooleanProperty::delegateForProperty() const
{
    return m_delegateType;
}
