#include "genericmultimodalityproperty.h"

GenericMultiModalityProperty::GenericMultiModalityProperty(const QString &nameForDomElement,
                                                           const QString &nameForDisplayRoleData,
                                                           AbstractDelegate::DelegateType delegateType,
                                                           const QMap<QString, QString> &modalitiesMap)
{
    m_nameForDomElement = nameForDomElement;
    m_nameForDisplayRoleData = nameForDisplayRoleData;
    m_delegateType = delegateType;
    m_modalitiesMap = modalitiesMap;
}

QVariant GenericMultiModalityProperty::updateDisplayRoleDataString(const QString &valueString)
{
    return m_modalitiesMap.value(valueString);
}

QString GenericMultiModalityProperty::updateCommandString(const QString &valueString)
{
    return valueString;
}

QString GenericMultiModalityProperty::domElementName() const
{
    return m_nameForDomElement;
}

QVariant GenericMultiModalityProperty::propertyNameForDisplayRoleData() const
{
    return m_nameForDisplayRoleData;
}

bool GenericMultiModalityProperty::isRequired() const
{
    return false;
}

void GenericMultiModalityProperty::setModalitiesMap(const QMap<QString, QString> modalitiesMap)
{
    m_modalitiesMap = modalitiesMap;
}

AbstractDelegate::DelegateType GenericMultiModalityProperty::delegateForProperty() const
{
    return m_delegateType;
}
