#ifndef GENERICMULTIMODALITYPROPERTY_H
#define GENERICMULTIMODALITYPROPERTY_H

#include "abstractproperty.h"

class GenericMultiModalityProperty : public AbstractProperty
{
public:
    GenericMultiModalityProperty(const QString &nameForDomElement,
                                 const QString &nameForDisplayRoleData,
                                 AbstractDelegate::DelegateType delegateType,
                                 const QMap<QString, QString> &modalitiesMap = QMap<QString, QString>());

    // Re-implemented pure virtual functions
    virtual QVariant updateDisplayRoleDataString(const QString &valueString);
    virtual QString updateCommandString(const QString &valueString);
    virtual QString domElementName() const;
    virtual QVariant propertyNameForDisplayRoleData() const;
    virtual bool isRequired() const;
    virtual AbstractDelegate::DelegateType delegateForProperty() const;

    void setModalitiesMap(const QMap<QString, QString> modalitiesMap);

private:
    QString m_nameForDomElement;
    QString m_nameForDisplayRoleData;
    AbstractDelegate::DelegateType m_delegateType;
    QMap<QString, QString> m_modalitiesMap;
};

#endif // GENERICMULTIMODALITYPROPERTY_H
