#ifndef GEOMETRYDATAPROPERTY_H
#define GEOMETRYDATAPROPERTY_H

#include "abstractproperty.h"

class GeometryDataProperty : public AbstractProperty
{
public:
    enum GeometryDataType {X, Y, XSize, YSize};
    GeometryDataProperty(GeometryDataProperty::GeometryDataType geometryDataType);

    // Re-implemented pure virtual functions
    virtual QVariant updateDisplayRoleDataString(const QString &valueString);
    virtual QString updateCommandString(const QString &valueString);
    virtual QString domElementName() const;
    virtual QVariant propertyNameForDisplayRoleData() const;
    virtual bool isRequired() const;
    virtual AbstractDelegate::DelegateType delegateForProperty() const;

private:
    GeometryDataProperty::GeometryDataType m_geometryDataType;
};

#endif // GEOMETRYDATAPROPERTY_H
