#ifndef GEOMETRYDATASETTER_H
#define GEOMETRYDATASETTER_H

#include "abstractsetter.h"
#include <QSpinBox>
#include <QComboBox>
#include <QLineEdit>
#include <QPushButton>

class GeometryDataSetter : public AbstractSetter
{
Q_OBJECT

public:
    explicit GeometryDataSetter(const QStringList &userDefinedNameList, QWidget *parent = 0);
    void setGeometryData(const QString &data);
    QString geometryData() const;

private:
    // GUI
    QSpinBox *spinBox;
    QLineEdit *lineEdit;
    QPushButton *button;
    QComboBox *comboBox;

private slots:
    void onCurrentComboBoxItemChanged(int pos);
    void onUserDefinedNameMenuItemTriggered();
    void onClearActionsTriggered();

};

#endif // GEOMETRYDATASETTER_H
