#include "helpobj.h"

#include "genericplainstringproperty.h"
#include "genericlabeledstringproperty.h"

HelpObj::HelpObj()
    : AbstractObj(AbstractObj::Help)
{
    GenericPlainStringProperty *nameProperty =
            new GenericPlainStringProperty("name", "Name", AbstractDelegate::Name);
    nameProperty->setValue("mycancelbutton");
    appendProperty(nameProperty);

    GenericLabeledStringProperty *view =
            new GenericLabeledStringProperty("view", "View topic", AbstractDelegate::GenericString);
    appendProperty(view);
}

QString HelpObj::commandString() const
{
    return "HELP" + standardInnerCommandString();
}

QString HelpObj::commandNameForDisplayRoleData() const
{
    return "Help button";
}

QString HelpObj::typeNameForDomElement() const
{
    return "help";
}

bool HelpObj::hasName() const
{
    return true;
}
