#include "iactionforscriptitemdelegate.h"
#include "iactioncompleter.h"
#include "iactionsetter.h"

IActionForScriptItemDelegate::IActionForScriptItemDelegate(const QAbstractItemModel *sourceModel)
{
    m_sourceModel = sourceModel;
}

QWidget *IActionForScriptItemDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                      const QModelIndex &index) const
{
    Q_UNUSED(option)

    // Completer
    IActionCompleter *completer = new IActionCompleter(m_sourceModel, parent);

    // IAction setter
    IActionSetter *iActionSetter = new IActionSetter(AbstractObj::Root, completer, m_sourceModel, parent);
    return iActionSetter;
}

void IActionForScriptItemDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    IActionSetter *iActionSetter = static_cast<IActionSetter*>(editor);
    iActionSetter->setIActionData(index.data(Qt::EditRole).toString());
}

void IActionForScriptItemDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                   const QModelIndex &index) const
{
    IActionSetter *iActionSetter = static_cast<IActionSetter*>(editor);
    model->setData(index, iActionSetter->iActionData());
}
