#include "includefilenamedelegate.h"
#include "includefilenamesetter.h"

IncludeFileNameDelegate::IncludeFileNameDelegate(QObject *parent)
    : AbstractDelegate(parent)
{
}

QWidget *IncludeFileNameDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
              const QModelIndex &index) const
{
    Q_UNUSED(option)
    IncludeFileNameSetter *includeFileNameSetter = new IncludeFileNameSetter(parent);
    return includeFileNameSetter;
}

void IncludeFileNameDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    IncludeFileNameSetter *includeFileNameSetter = static_cast<IncludeFileNameSetter*>(editor);
    includeFileNameSetter->setData(index.data(Qt::EditRole).toString());
}

void IncludeFileNameDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                            const QModelIndex &index) const
{
    IncludeFileNameSetter *includeFileNameSetter = static_cast<IncludeFileNameSetter*>(editor);
    model->setData(index, includeFileNameSetter->data().trimmed());
}
