#include "listboxobj.h"

ListBoxObj::ListBoxObj()
    : AbstractControlObj(AbstractObj::ListBox)
{
    xSizeProperty->setValue("200");
    ySizeProperty->setValue(".");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    noMemoryProperty =
            new GenericBooleanProperty("nomemory", "No memory", AbstractDelegate::NoMemory);
    appendProperty(noMemoryProperty);

    contentsProperty = new ContentsProperty;
    appendProperty(contentsProperty);

    valuesProperty =
            new GenericLabeledStringProperty("values", "Values", AbstractDelegate::Values);
    appendProperty(valuesProperty);

    defaultProperty =
            new GenericLabeledStringProperty("default", "Default", AbstractDelegate::DefaultStrVal);
    appendProperty(defaultProperty);

    onDblClickProperty =
            new GenericLabeledStringProperty("ondblclick", "On double click",
                                             AbstractDelegate::IAction);
    appendProperty(onDblClickProperty);

    onSelChangeProperty =
            new GenericLabeledStringProperty("onselchange", "On selection changed",
                                             AbstractDelegate::IAction);
    appendProperty(onSelChangeProperty);

    onSelChangeListProperty =
            new GenericLabeledStringProperty("onselchangelist", "On selection changed list",
                                             AbstractDelegate::IAction);
    appendProperty(onSelChangeListProperty);

    optionProperty =
            new GenericLabeledStringProperty("option", "Option", AbstractDelegate::GenericString);
    appendProperty(optionProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);

}

QString ListBoxObj::commandString() const
{
    return "LISTBOX" + standardInnerCommandString();
}

QString ListBoxObj::commandNameForDisplayRoleData() const
{
    return "List box";
}

QString ListBoxObj::typeNameForDomElement() const
{
    return "listbox";
}

