#ifndef LISTBOXOBJ_H
#define LISTBOXOBJ_H

#include "abstractcontrolobj.h"

// Properties
#include "genericbooleanproperty.h"
#include "contentsproperty.h"

class ListBoxObj : public AbstractControlObj
{
public:
    ListBoxObj();

    // Re-implemented pure virtual functions
    virtual QString commandString() const;
    virtual QString commandNameForDisplayRoleData() const;
    virtual QString typeNameForDomElement() const;

    // Properties
    GenericLabeledStringProperty *labelProperty;
    GenericLabeledStringProperty *errorProperty;
    GenericBooleanProperty *noMemoryProperty;
    ContentsProperty *contentsProperty;
    GenericLabeledStringProperty *valuesProperty;
    GenericLabeledStringProperty *defaultProperty;
    GenericLabeledStringProperty *onDblClickProperty;
    GenericLabeledStringProperty *onSelChangeProperty;
    GenericLabeledStringProperty *onSelChangeListProperty;
    GenericLabeledStringProperty *optionProperty;
    GenericLabeledStringProperty *toolTipProperty;
};

#endif // LISTBOXOBJ_H
