#include "listcontentdelegate.h"
#include "listcontentsetter.h"
#include <QDebug>

ListContentDelegate::ListContentDelegate(QObject *parent)
    : AbstractDelegate(parent)
{
}

QWidget *ListContentDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
              const QModelIndex &index) const
{
    Q_UNUSED(option)
    Q_UNUSED(index)
    ListContentSetter *listContentSetter = new ListContentSetter(parent);
    return listContentSetter;
}

void ListContentDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    ListContentSetter *listContentSetter = static_cast<ListContentSetter*>(editor);
    QString value = index.data(Qt::EditRole).toString();
    listContentSetter->setItemList(value.split("; ", QString::SkipEmptyParts));
}

void ListContentDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                       const QModelIndex &index) const
{
    ListContentSetter *listContentSetter = static_cast<ListContentSetter*>(editor);
    QStringList itemList = listContentSetter->itemList();
    bool firstItemWasInserted = false;
    QString value;
    for (int i=0; i<itemList.count(); i++)
    {
        if (firstItemWasInserted)
            value += "; " + itemList.at(i);
        else
            value += itemList.at(i);
        firstItemWasInserted = true;
    }
    model->setData(index, value);
}

void ListContentDelegate::updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option,
                          const QModelIndex &index) const
{
    Q_UNUSED(index)
    QRect cellRect = option.rect;
    cellRect.setHeight(150);
    editor->setGeometry(cellRect);
}
