#include "listcontentlistview.h"

ListContentListView::ListContentListView(QWidget *parent) :
    QListView(parent)
{
    // Context menu
    removeItemAction = new QAction("Remove", this);
    connect(removeItemAction, SIGNAL(triggered()), this, SLOT(onRemoveItemActionTriggered()));
    contextMenu = new QMenu(this);
    contextMenu->addAction(removeItemAction);
}

void ListContentListView::contextMenuEvent(QContextMenuEvent *event)
{
    if (selectionModel()->selectedIndexes().isEmpty())
        removeItemAction->setDisabled(true);
    else
        removeItemAction->setDisabled(false);
    contextMenu->exec(event->globalPos());
}

void ListContentListView::onRemoveItemActionTriggered()
{
    emit removeItem();
}
