#ifndef LISTCONTENTMODEL_H
#define LISTCONTENTMODEL_H

#include <QAbstractListModel>
#include <QStringList>
#include <QSize>

class ListContentModel : public QAbstractListModel
{
Q_OBJECT

public:
    explicit ListContentModel(QObject *parent = 0,
                              bool isNewNameAutomatic = true,
                              QSize sizeHint = QSize());
    
    // Re-implemented virtual functions
    int rowCount(const QModelIndex &parent = QModelIndex()) const;
    QVariant data(const QModelIndex &index, int role) const;
    Qt::ItemFlags flags(const QModelIndex &index) const;
    bool setData(const QModelIndex &index, const QVariant &value, int role = Qt::EditRole);
    bool insertRow(int row, const QModelIndex &parent = QModelIndex());
    bool removeRow(int row, const QModelIndex &parent = QModelIndex());

    void setStringList(const QStringList &stringList);
    void moveItemUp(int row);
    void moveItemDown(int row);
    QStringList stringList();

private:
    QStringList m_stringList;
    bool isNewNameAutomatic;
    QSize sizeHint;

    // Functions
    QString nameForNewItem();
};

#endif // LISTCONTENTMODEL_H
