#include "maxforeditdelegate.h"

#include <QSpinBox>

MaxForEditDelegate::MaxForEditDelegate(QObject *parent)
    : AbstractDelegate(parent)
{
}

QWidget *MaxForEditDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
              const QModelIndex &index) const
{
    Q_UNUSED(option)
    Q_UNUSED(index)
    QSpinBox *spinBox = new QSpinBox(parent);
    spinBox->setRange(-1, 99999);
    spinBox->setSpecialValueText("Not specified");
    return spinBox;
}

void MaxForEditDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    QSpinBox *spinBox = static_cast<QSpinBox*>(editor);
    QString value = index.data(Qt::EditRole).toString();
    if (value.isEmpty())
        spinBox->setValue(-1);
    else
        spinBox->setValue(value.toInt());
}

void MaxForEditDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                            const QModelIndex &index) const
{
    QSpinBox *spinBox = static_cast<QSpinBox*>(editor);
    int value = spinBox->value();
    if (value == -1)
        model->setData(index, "");
    else
        model->setData(index, QString("%1").arg(value));
}
