#include "objectboxitem.h"

ObjectBoxItem::ObjectBoxItem(const QString &string, const QString &filterString, const QVariant &objType)
{
    m_string = string;
    m_filterString = filterString;
    m_objType = objType;
    m_parentItem = 0;
}

void ObjectBoxItem::appendItem(ObjectBoxItem *item)
{
    m_childItems.append(item);
    item->m_parentItem = this;
}

int ObjectBoxItem::childCount()
{
    return m_childItems.count();
}

ObjectBoxItem *ObjectBoxItem::parent()
{
    return m_parentItem;
}

ObjectBoxItem *ObjectBoxItem::itemAt(int row)
{
    return m_childItems.at(row);
}

int ObjectBoxItem::row() const
{
    if (m_parentItem)
        return m_parentItem->m_childItems.indexOf(const_cast<ObjectBoxItem*>(this));
    else
        return -1;
}

QString ObjectBoxItem::string()
{
    return m_string;
}

QString ObjectBoxItem::filterString()
{
    return m_filterString;
}

QVariant ObjectBoxItem::objType()
{
    return m_objType;
}
