#ifndef OBJECTBOXITEM_H
#define OBJECTBOXITEM_H

#include <QList>
#include <QString>
#include <QVariant>

class ObjectBoxItem
{
public:
    ObjectBoxItem(const QString &string = QString(),
                  const QString &filterString = QString(),
                  const QVariant &objType = QVariant());
    void appendItem(ObjectBoxItem *item);
    int childCount();
    ObjectBoxItem *parent();
    ObjectBoxItem *itemAt(int row);
    int row() const;
    QString string();
    QString filterString();
    QVariant objType();

private:
    QString m_string;
    QString m_filterString;
    QVariant m_objType;
    ObjectBoxItem* m_parentItem;
    QList<ObjectBoxItem*> m_childItems;
};

#endif // OBJECTBOXITEM_H
