#include "pleasefindstatadialog.h"

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QLabel>
#include <QPushButton>
#include <QFileDialog>
#include <QDebug>

PleaseFindStataDialog::PleaseFindStataDialog(QWidget *parent) :
    QDialog(parent)
{
    setWindowTitle("Visua");

    // Layout
    QVBoxLayout *layout = new QVBoxLayout;
    setLayout(layout);

    // Label
    QLabel *label = new QLabel("You have not yet informed Visua about the location of the Stata executable.\nPlease find the Stata executable (.exe) in your Stata folder.");
    layout->addWidget(label);

    // Horizontal Layout
    QHBoxLayout *horizontalLayout = new QHBoxLayout;
    layout->addLayout(horizontalLayout);

    // Stretch
    horizontalLayout->addStretch();

    // Cancel button
    QPushButton *cancelButton = new QPushButton("Cancel", this);
    connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));
    horizontalLayout->addWidget(cancelButton);

    // Find button
    QPushButton *findButton = new QPushButton("Find...", this);
    connect(findButton, SIGNAL(clicked()), this, SLOT(onFindButtonClicked()));
    horizontalLayout->addWidget(findButton);
}

void PleaseFindStataDialog::onFindButtonClicked()
{
    QString fileName = QFileDialog::getOpenFileName(
                this,
                "Find Stata executable",
                ".",
                "Executable program (*.exe)");

    if (!fileName.isEmpty())
    {
        stataLocation = fileName;
        accept();
    }
}

QString PleaseFindStataDialog::getStataLocation()
{
    return stataLocation;
}
