#ifndef POSITIONGEOMETRYDATAPROPERTY_H
#define POSITIONGEOMETRYDATAPROPERTY_H

#include "abstractproperty.h"

class PositionGeometryDataProperty : public AbstractProperty
{
public:
    enum GeometryDataType {X, Y, XSize, YSize};
    PositionGeometryDataProperty(PositionGeometryDataProperty::GeometryDataType geometryDataType,
                                 bool defaultValueAllowed);

    // Re-implemented pure virtual functions
    virtual QVariant updateDisplayRoleDataString(const QString &valueString);
    virtual QString updateCommandString(const QString &valueString);
    virtual QString domElementName() const;
    virtual QVariant propertyNameForDisplayRoleData() const;
    virtual bool isRequired() const;
    virtual AbstractDelegate::DelegateType delegateForProperty() const;

private:
    PositionGeometryDataProperty::GeometryDataType m_geometryDataType;
    bool m_defaultValueAllowed;
};

#endif // POSITIONGEOMETRYDATAPROPERTY_H
