#include "programcodeadvancededitor.h"
#include <QVBoxLayout>
#include <QHBoxLayout>

ProgramCodeAdvancedEditor::ProgramCodeAdvancedEditor(QWidget *parent) :
    QDialog(parent)
{
    setWindowTitle("Visua - Program code advanced editor");
    setWindowFlags((windowFlags() | Qt::Window | Qt::CustomizeWindowHint)
                   & ~Qt::WindowContextHelpButtonHint);
    setGeometry(50, 50, 500, 400);

    // Layout
    QVBoxLayout *layout = new QVBoxLayout;
    layout->setMargin(0);
    layout->setContentsMargins(0, 0, 0, 0);
    layout->setSpacing(0);
    setLayout(layout);

    // Text edit
    textEdit = new QTextEdit;
    textEdit->setLineWrapMode(QTextEdit::NoWrap);
    layout->addWidget(textEdit);

    // Buttons layout
    QHBoxLayout *buttonsLayout = new QHBoxLayout;
    buttonsLayout->addStretch();
    layout->addLayout(buttonsLayout);

    // Cancel button
    cancelButton = new QPushButton("Cancel");
    buttonsLayout->addWidget(cancelButton);

    // Ok Button
    okButton = new QPushButton("Ok");
    buttonsLayout->addWidget(okButton);

    // Connections
    connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));
    connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));}

void ProgramCodeAdvancedEditor::setCodeData(const QString &data)
{
    textEdit->setPlainText(data);
}

QString ProgramCodeAdvancedEditor::codeData()
{
    return textEdit->toPlainText();
}
