#include "programcodesetter.h"
#include <QVBoxLayout>
#include <QHBoxLayout>
#include "programcodeadvancededitor.h"

ProgramCodeSetter::ProgramCodeSetter(QWidget *parent)
    : AbstractSetter(parent)
{
    // Layout
    QVBoxLayout *layout = new QVBoxLayout;
    layout->setMargin(0);
    layout->setContentsMargins(0, 0, 0, 0);
    layout->setSpacing(0);
    setLayout(layout);

    // Text edit
    textEdit = new QTextEdit;
    textEdit->setLineWrapMode(QTextEdit::NoWrap);
    layout->addWidget(textEdit);

    // Horizontal layout
    QHBoxLayout *bottomLayout = new QHBoxLayout;
    bottomLayout->setMargin(0);
    bottomLayout->setContentsMargins(0, 0, 0, 0);
    bottomLayout->setSpacing(0);
    layout->addLayout(bottomLayout);

    // Advanced editor button
    advancedEditorButton = new QToolButton;
    advancedEditorButton->setIcon(QIcon(":images/icons/advancededitor.png"));
    advancedEditorButton->setToolTip("Advanced editor");
    bottomLayout->addStretch();
    connect(advancedEditorButton, SIGNAL(clicked()), this, SLOT(onAdvancedEditorButtonClicked()));
    bottomLayout->addWidget(advancedEditorButton);
}

void ProgramCodeSetter::setCodeData(const QString &data)
{
    textEdit->setPlainText(data);
}

QString ProgramCodeSetter::codeData() const
{
    return textEdit->toPlainText();
}

void ProgramCodeSetter::onAdvancedEditorButtonClicked()
{
    ProgramCodeAdvancedEditor progamCodeAdvancedEditor(this);
    progamCodeAdvancedEditor.setCodeData(codeData());
    if (progamCodeAdvancedEditor.exec() == QDialog::Accepted)
        textEdit->setText(progamCodeAdvancedEditor.codeData());
}
