#include "scriptiactionlistdelegate.h"
#include "scriptiactionlistsetter.h"
#include <QSortFilterProxyModel>
#include "iactioncompleter.h"
#include <QDebug>

ScriptIActionListDelegate::ScriptIActionListDelegate(QObject *parent)
    : AbstractDelegate(parent)
{
}

QWidget *ScriptIActionListDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
              const QModelIndex &index) const
{
    Q_UNUSED(option)
    Q_UNUSED(index)

    // Retrive source model
    const QSortFilterProxyModel *proxyModel = static_cast<const QSortFilterProxyModel*>(index.model());
    QModelIndex sourceIndex = proxyModel->mapToSource(index);
    const QAbstractItemModel *sourceModel = sourceIndex.model();

    ScriptIActionListSetter *scriptIActionListSetter = new ScriptIActionListSetter(sourceModel, parent);
    return scriptIActionListSetter;
}

void ScriptIActionListDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    ScriptIActionListSetter *scriptIActionListSetter = static_cast<ScriptIActionListSetter*>(editor);

    QString value = index.data(Qt::EditRole).toString();
    scriptIActionListSetter->setIActionList(value.split("\n", QString::SkipEmptyParts));
}

void ScriptIActionListDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                       const QModelIndex &index) const
{
    ScriptIActionListSetter *scriptIActionListSetter = static_cast<ScriptIActionListSetter*>(editor);
    QStringList itemList = scriptIActionListSetter->iActionList();
    bool firstItemWasInserted = false;
    QString value;
    for (int i=0; i<itemList.count(); i++)
    {
        if (firstItemWasInserted)
            value += "\n" + itemList.at(i);
        else value += itemList.at(i);
        firstItemWasInserted = true;
    }
    model->setData(index, value);
}

void ScriptIActionListDelegate::updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option,
                          const QModelIndex &index) const
{
    Q_UNUSED(index)
    QRect cellRect = option.rect;
    cellRect.setHeight(150);
    editor->setGeometry(cellRect);
}
