#include "scriptiactionlistproperty.h"

ScriptIActionListProperty::ScriptIActionListProperty()
{
    setValue("");
}

QVariant ScriptIActionListProperty::updateDisplayRoleDataString(const QString &valueString)
{
    return valueString;
}

QString ScriptIActionListProperty::updateCommandString(const QString &valueString)
{
    QString items = valueString;
    QStringList itemList = items.split("\n", QString::SkipEmptyParts);
    QString returnString;
    returnString += "\nBEGIN";
    for (int i=0; i<itemList.count(); i++)
        returnString += "\n  " + itemList.at(i);
    returnString += "\nEND";
    return returnString;
}

QString ScriptIActionListProperty::domElementName() const
{
    return "iactionlist";
}

QVariant ScriptIActionListProperty::propertyNameForDisplayRoleData() const
{
    return "I-action list";
}

bool ScriptIActionListProperty::isRequired() const
{
    return true;
}

AbstractDelegate::DelegateType ScriptIActionListProperty::delegateForProperty() const
{
    return AbstractDelegate::ScriptIActionListDelegate;
}

void ScriptIActionListProperty::setFromObjDomElement(const QDomElement &domElement)
{
    QDomNode domNode = domElement.namedItem(domElementName());
    if (domNode.isNull())
        setValue("");
    else
    {
        QString string;
        bool atLeastOneItem = false;
        QDomNode itemNode = domNode.toElement().firstChild();
        while (!itemNode.isNull())
        {
            if (itemNode.toElement().tagName() == "iactionlistitem")
            {
                if (atLeastOneItem)
                    string += "\n" + itemNode.childNodes().at(0).toText().data();
                else
                    string += itemNode.childNodes().at(0).toText().data();
                atLeastOneItem = true;
            }
            itemNode = itemNode.nextSibling();
        }
        setValue(string);
    }
}

QDomElement ScriptIActionListProperty::domElement(QDomDocument &xmlDocument) const
{
    QDomElement domElement = xmlDocument.createElement(domElementName());

    if (value().isEmpty())
        return domElement;
    else
    {
        QStringList items = value().split("\n");
        for (int i=0; i<items.count(); i++)
        {
            QDomElement listItemElement = xmlDocument.createElement("iactionlistitem");
            QDomText listItemText = xmlDocument.createTextNode(items.at(i));
            listItemElement.appendChild(listItemText);
            domElement.appendChild(listItemElement);
        }
        return domElement;
    }
}

