#ifndef SCRIPTIACTIONLISTSETTER_H
#define SCRIPTIACTIONLISTSETTER_H

#include "abstractsetter.h"
#include <QStringList>
#include <QStandardItemModel>
#include <QAbstractItemModel>
#include <QListView>
#include <QToolButton>
#include "listcontentmodel.h"

class ScriptIActionListSetter : public AbstractSetter
{
Q_OBJECT

public:
    ScriptIActionListSetter(const QAbstractItemModel *sourceModel, QWidget *parent);
    void setIActionList(const QStringList &list);
    QStringList iActionList();

    // Model
    ListContentModel *m_model;

    // Source model
    const QAbstractItemModel *m_sourceModel;

    // GUI
    QListView *listView;
    QToolButton *addButton;
    QToolButton *removeButton;
    QToolButton *upButton;
    QToolButton *downButton;

private slots:
    void onAddButtonClicked();
    void onRemoveButtonClicked();
    void onUpButtonClicked();
    void onDownButtonClicked();

};

#endif // SCRIPTIACTIONLISTSETTER_H
