#ifndef SPINNEROBJ_H
#define SPINNEROBJ_H

#include "abstractcontrolobj.h"

// Properties
#include "genericbooleanproperty.h"
#include "genericlabeledstringproperty.h"

class SpinnerObj : public AbstractControlObj
{
public:
    SpinnerObj();

    // Re-implemented pure virtual functions
    virtual QString commandString() const;
    virtual QString commandNameForDisplayRoleData() const;
    virtual QString typeNameForDomElement() const;

    // Properties
    GenericLabeledStringProperty *labelProperty;
    GenericLabeledStringProperty *errorProperty;
    GenericLabeledStringProperty *defaultProperty;
    GenericBooleanProperty *noMemoryProperty;
    GenericLabeledStringProperty *minForSpinnerProperty;
    GenericLabeledStringProperty *maxForSpinnerProperty;
    GenericLabeledStringProperty *onChangeProperty;
    GenericLabeledStringProperty *optionProperty;
    GenericLabeledStringProperty *toolTipProperty;
};

#endif // SPINNEROBJ_H
