#ifndef STATALOGVIEW_H
#define STATALOGVIEW_H

#include <QTextEdit>
#include <QtGui>

class StataLogView : public QMainWindow
{
Q_OBJECT

public:
    explicit StataLogView(QWidget *parent = 0);
    bool loadLastLogFile();

private:
    // GUI
    QTextEdit *textEdit;
    QMenu *fileMenu;
    QMenu *logFileMenu;

    // Actions
    QAction *saveAsAction;
    QAction *exitAction;
    QAction *updateAction;
    QAction *showPathOfLogFileAction;

    // Functions
    void createActions();
    void createMenus();

private slots:
    void onUpdateActionTriggered();
    void onShowPathOfLogActionTriggered();
    void onSaveAsActionTriggered();
};

#endif // STATALOGVIEW_H
