#include "textboxobj.h"

TextBoxObj::TextBoxObj()
    : AbstractControlObj(AbstractObj::TextBox)
{
    xSizeProperty->setValue("200");
    ySizeProperty->setValue(".");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    labelProperty->setValue("Textbox");
    appendProperty(labelProperty);

    alignmentProperty = new AlignmentProperty;
    appendProperty(alignmentProperty);
}

QString TextBoxObj::commandString() const
{
    return "TEXTBOX" + standardInnerCommandString();
}

QString TextBoxObj::commandNameForDisplayRoleData() const
{
    return "Text box";
}

QString TextBoxObj::typeNameForDomElement() const
{
    return "textbox";
}

