#include "textobj.h"

TextObj::TextObj()
    : AbstractControlObj(AbstractObj::Text)
{
    xSizeProperty->setValue(".");
    ySizeProperty->setValue(".");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    labelProperty->setValue("Text");
    appendProperty(labelProperty);

    alignmentProperty = new AlignmentProperty;
    appendProperty(alignmentProperty);
}

QString TextObj::commandString() const
{
    return "TEXT" + standardInnerCommandString();
}

QString TextObj::commandNameForDisplayRoleData() const
{
    return "Text";
}

QString TextObj::typeNameForDomElement() const
{
    return "text";
}
